/*
** Copyright 1995-1996 by the Massachusetts Institute of Technology.  All
** rights reserved. For more information, see the file COPYING which came
** with this source distribution.
*/

#include "MIDI_lib.h"
#include "Statistic.h"
#include "OMS_app.h"

void
MIDI_msg::
to_OMS( DWORD* p, UINT *n ) const
{
	*p = s + (d1<<8) + (d2 << 16);
	*n = (UINT)node;
}


void
MIDI_msg::
fr_OMS( DWORD p1, DWORD p2, UINT n )
{
	time = oap->time();
	node = (ioref) n;
	s = (unsigned char) (p1 & 0xff);
	d1 = (unsigned char) ((p1 >> 8) & 0xff);
	d2 = (unsigned char) ((p1 >> 16) & 0xff);
}


void
MIDI_msg::
set( int msgt, int lsn, int dat1, int dat2, int in_node )
{
	set_stat_byt( msgt, lsn ); // sets s
	d1 = dat1;
	d2 = dat2;
	node = in_node;
}

bool
MIDI_msg::
is_on_for( const MIDI_msg& m ) const
{
	return m.is_note_end()
		? ( node == m.node && chan() == m.chan() && key() == m.key() )
		: false;
}


//--------------------------------------------------------------------------------------------------

parser::
parser()
{
	for (int i=0; i<8; i++) msg_hnd[i] = NULL;
}
/* Initializes all handlers to NULL so that in creating a parser, the user need only fill in the 
ones that are needed without worrying about setting others NULL. */

parser::
~parser()
{
}

// Authors: Ben Denckla, Patrick Pelletier
